// Code generated by kun; DO NOT EDIT.
// github.com/RussellLuo/kun

package fileupload

import (
	"reflect"

	"github.com/RussellLuo/kun/pkg/httpcodec"
	"github.com/RussellLuo/kun/pkg/oas2"
)

var (
	base = `swagger: "2.0"
info:
  title: "No Title"
  version: "0.0.0"
  description: "Service is used for uploading files."
  license:
    name: "MIT"
host: "example.com"
basePath: "/"
schemes:
  - "https"
consumes:
  - "application/json"
produces:
  - "application/json"
`

	paths = `
paths:
  /upload:
    post:
      description: "Upload uploads a file."
      operationId: "Upload"
      parameters:
        - name: body
          in: body
          schema:
            $ref: "#/definitions/UploadRequestBody"
      %s
`
)

func getResponses(schema oas2.Schema) []oas2.OASResponses {
	return []oas2.OASResponses{
		oas2.GetOASResponses(schema, "Upload", 204, &UploadResponse{}),
	}
}

func getDefinitions(schema oas2.Schema) map[string]oas2.Definition {
	defs := make(map[string]oas2.Definition)

	oas2.AddDefinition(defs, "UploadRequestBody", reflect.ValueOf(&struct {
		File *httpcodec.FormFile `json:"file"`
	}{}))
	oas2.AddResponseDefinitions(defs, schema, "Upload", 204, (&UploadResponse{}).Body())

	return defs
}

func OASv2APIDoc(schema oas2.Schema) string {
	resps := getResponses(schema)
	paths := oas2.GenPaths(resps, paths)

	defs := getDefinitions(schema)
	definitions := oas2.GenDefinitions(defs)

	return base + paths + definitions
}
