// Code generated by kun; DO NOT EDIT.
// github.com/RussellLuo/kun

package messaging

import (
	"context"
	"net/http"

	"github.com/RussellLuo/kun/pkg/httpcodec"
	"github.com/RussellLuo/kun/pkg/httpoption"
	"github.com/RussellLuo/kun/pkg/oas2"
	"github.com/go-chi/chi"
	kithttp "github.com/go-kit/kit/transport/http"
)

func NewHTTPRouter(svc Service, codecs httpcodec.Codecs, opts ...httpoption.Option) chi.Router {
	r := chi.NewRouter()
	options := httpoption.NewOptions(opts...)

	r.Method("GET", "/api", oas2.Handler(OASv2APIDoc, options.ResponseSchema()))

	var codec httpcodec.Codec
	var validator httpoption.Validator
	var kitOptions []kithttp.ServerOption

	codec = codecs.EncodeDecoder("GetMessage")
	validator = options.RequestValidator("GetMessage")
	r.Method(
		"GET", "/messages/{messageID}",
		kithttp.NewServer(
			MakeEndpointOfGetMessage(svc),
			decodeGetMessageRequest(codec, validator),
			httpcodec.MakeResponseEncoder(codec, 200),
			append(kitOptions,
				kithttp.ServerErrorEncoder(httpcodec.MakeErrorEncoder(codec)),
			)...,
		),
	)

	codec = codecs.EncodeDecoder("GetMessage")
	validator = options.RequestValidator("GetMessage")
	r.Method(
		"GET", "/users/{userID}/messages/{messageID}",
		kithttp.NewServer(
			MakeEndpointOfGetMessage(svc),
			decodeGetMessage1Request(codec, validator),
			httpcodec.MakeResponseEncoder(codec, 200),
			append(kitOptions,
				kithttp.ServerErrorEncoder(httpcodec.MakeErrorEncoder(codec)),
			)...,
		),
	)

	return r
}

func decodeGetMessageRequest(codec httpcodec.Codec, validator httpoption.Validator) kithttp.DecodeRequestFunc {
	return func(_ context.Context, r *http.Request) (interface{}, error) {
		var _req GetMessageRequest

		messageID := []string{chi.URLParam(r, "messageID")}
		if err := codec.DecodeRequestParam("messageID", messageID, &_req.MessageID); err != nil {
			return nil, err
		}

		if err := validator.Validate(&_req); err != nil {
			return nil, err
		}

		return &_req, nil
	}
}

func decodeGetMessage1Request(codec httpcodec.Codec, validator httpoption.Validator) kithttp.DecodeRequestFunc {
	return func(_ context.Context, r *http.Request) (interface{}, error) {
		var _req GetMessageRequest

		userID := []string{chi.URLParam(r, "userID")}
		if err := codec.DecodeRequestParam("userID", userID, &_req.UserID); err != nil {
			return nil, err
		}

		messageID := []string{chi.URLParam(r, "messageID")}
		if err := codec.DecodeRequestParam("messageID", messageID, &_req.MessageID); err != nil {
			return nil, err
		}

		if err := validator.Validate(&_req); err != nil {
			return nil, err
		}

		return &_req, nil
	}
}
